<?php
/** 
*
* @package group_time
* @version 0.0.3
* @copyright (c) 2009 Lolovoisin
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

/** Function group_time */
function group_time ()
{
	global $db, $user, $phpbb_root_path, $phpEx;
	
	// Si on n'est pas enregistré, on n'entre pas.
	if (!$user->data['is_registered'])
	{
		return false;
	}
	
	$group_time_id = array();
	
	if (!function_exists('group_user_del'))
	{
		include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
	}

	if (!function_exists('submit_pm'))
	{
		include($phpbb_root_path . 'includes/functions_privmsgs.' . $phpEx);
	}
	
	// C'est partie pour une "zolie" requête
	// Tout d'abord on fait la liste des groupes du membre qui vient de se connecter avec un nbre_jour_limit > 0  et dont le temps dans le ou les groupe(s) est dépassé
	// On récupére aussi les info du MP si il y en a
	// Et on ne récupère pas non plus les chefs de groupe, ce serait bien de les laisser dedans.
	$sql = $db->sql_build_query('SELECT', array(
		'SELECT'	=> 'g.group_id, g.group_nbre_jour_limit, g.group_time_pm_enable, g.group_time_id_sender, g.group_time_subject, g.group_time_pm, g.group_time_forum_to, g.group_time_default, ug.user_id, ug.user_time_entrance',

		'FROM'		=> array(
			GROUPS_TABLE	=> 'g'
		),

		'LEFT_JOIN'	=> array(
			array(
				'FROM'	=> array(USER_GROUP_TABLE => 'ug'),
				'ON'	=> 'g.group_id = ug.group_id'
				)
		),

		'WHERE'		=> 'g.group_nbre_jour_limit > 0 ' . '
			AND '. time() . ' - ug.user_time_entrance > g.group_nbre_jour_limit * 86400
			AND ug.group_leader = 0
			AND ug.user_id = '. $user->data['user_id']
	));		
	
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		//Nous avons  la liste des ID du ou des groupe(s) auquel appartient le membre et dont le membre ne doit plus en faire parti.
		//On va donc le sortir de ce groupe.
		group_user_del($row['group_id'], $user->data['user_id'], false, false, true);

		// Puis on vérifie si on doit envoyer un MP.
		if ($row['group_time_pm_enable'] == 1)
		{
			$sujet = $row['group_time_subject'];
			$message = $row['group_time_pm'];
			
			//Ici une autre ch'tite requête pour savoir qui envoie, en fonction de l'ID du sender choisi dans le MODs
			$sql = 'SELECT user_id, user_ip, username
				FROM ' . USERS_TABLE . ' 
				WHERE user_id = ' . $row['group_time_id_sender'];
			$result2 = $db->sql_query($sql);
			$send_pm_group_time = $db->sql_fetchrow($result2);
			$db->sql_freeresult($result2);
			
			$uid			= $bitfield			= $options		= '';
			$allow_bbcode	= $allow_smilies	= $allow_urls   = $img_status   = $flash_status = true;

			generate_text_for_storage($message, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

			$group_time_pm_data = array(
				'address_list'			=> array('u' => array($user->data['user_id'] => 'to')),
				'from_user_id'			=> $row['group_time_id_sender'],
				'from_user_ip'			=> $send_pm_group_time['user_ip'],
				'from_username'			=> $send_pm_group_time['username'],
				'enable_sig'			=> false,
				'enable_bbcode'			=> true,
				'enable_smilies'		=> true,
				'enable_urls'			=> true,
				'reply_from_root_level'	=> 0,
				'reply_from_msg_id'		=> 0,
				'icon_id'				=> 0,
				'bbcode_bitfield'		=> $bitfield,
				'bbcode_uid'			=> $uid,
				'message'				=> $message,
			);
			
			//Et hop, on envoie le MP.
			submit_pm('post', $sujet, $group_time_pm_data);		
		}	
		
		$default = false;
		//On vérifie si le groupe devient un groupe par défaut
		if ($row['group_time_default'] == 1)
		{
			$default = true;
		}
		//On ajoute le membre au groupe spécifié et on le mets par défaut si demandé
		group_user_add($row['group_time_forum_to'], $user->data['user_id'], false, false, $default, 0, 0, false);
	}
	$db->sql_freeresult($result);
}
?>